import 'package:flutter/material.dart';
import 'package:flutter/scheduler.dart';
import './route_complete_mixin.dart';
import './route_ani_observer_provider.dart';
import './route_ani_manage.dart';
import 'dart:async';

mixin RouteAniListenerMixin<T extends StatefulWidget> on State<T>, RouteAniCompleteMixin {

  @override
  void initState() {
    SchedulerBinding.instance.addPostFrameCallback((_) {
      RouteAniManage routeAniManage = RouteAniObserverProvider.of(context);
      routeAniManage.addRouteAniCompleteHandler(context, this);
      routeAniManage.addRouteListener(context);
    });
//    Future.delayed(Duration.zero, () {
//      RouteAniManage routeAniManage = RouteAniObserverProvider.of(context);
//      routeAniManage.addRouteAniCompleteHandler(context, this);
//      routeAniManage.addRouteListener(context);
//    });
    super.initState();
  }

  @override
  void dispose() {
//    RouteAniManage routeAniManage = RouteAniObserverProvider.of(context);
//    ModalRoute modalRoute = ModalRoute.of(context);
//    routeAniManage.removeRouteRelativeHandler(modalRoute);
    super.dispose();
  }
}